package org.bitbucket.bradleysmithllc.etlagent.informatica.dto;

import org.bitbucket.bradleysmithllc.etlagent.dto.GenericResponseDTO;
import org.bitbucket.bradleysmithllc.etlunit.util.HashMapArrayList;
import org.bitbucket.bradleysmithllc.etlunit.util.MapList;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ExecuteWorkflowResponseDTO extends GenericResponseDTO
{
	private response_code informaticaResponseCode = response_code.okay;

	private final Map<RemoteFile.fileType, List<RemoteFile>> responseFiles = new HashMap<RemoteFile.fileType, List<RemoteFile>>();

	public void setInformaticaErrorMessage(String msg)
	{
		informaticaResponseCode = response_code.failed;
		setResponseMessage(msg);
	}

	public response_code getInformaticaResponseCode() {
		return informaticaResponseCode;
	}

	public void addResponseFile(RemoteFile remote) {
		List<RemoteFile> remoteFileList = responseFiles.get(remote.getType());

		if (remoteFileList != null)
		{
			for (RemoteFile remoteFile : remoteFileList)
			{
				if (remoteFile.sameId(remote))
				{
					throw new IllegalArgumentException("Remote file name and fileType already added");
				}
			}
		}
		else
		{
			remoteFileList = new ArrayList<RemoteFile>();
			responseFiles.put(remote.getType(), remoteFileList);
		}

		remoteFileList.add(remote);
	}

	public Map<RemoteFile.fileType, List<RemoteFile>> getResponseFiles() {
		return responseFiles;
	}
}