package org.bitbucket.bradleysmithllc.etlagent.informatica.dto;

import org.apache.commons.io.FileUtils;

import java.io.File;
import java.io.IOException;
import java.util.List;

public class ImportWorkflowRequestDTO extends BaseIntegrationServiceRequestDTO
{
	private final String folderPrefix;
	private final String workflowName;
	private final String workflowXml;
	private final List<String> folderList;

	public ImportWorkflowRequestDTO(String folderPrefix, String workflowName, File workflowXml, List<String> folderList) throws IOException {
		this.folderPrefix = folderPrefix;
		this.workflowName = workflowName;
		this.workflowXml = FileUtils.readFileToString(workflowXml);
		this.folderList = folderList;
	}

	public ImportWorkflowRequestDTO(String folderPrefix, String workflowName, File workflowXml) throws IOException {
		this.folderPrefix = folderPrefix;
		this.workflowName = workflowName;
		this.workflowXml = FileUtils.readFileToString(workflowXml);
		folderList = null;
	}

	public String getFolderPrefix() {
		return folderPrefix;
	}

	public String getWorkflowName() {
		return workflowName;
	}

	public String getWorkflowXml() {
		return workflowXml;
	}

	public List<String> getFolderList() {
		return folderList;
	}
}